'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _reselect = require('reselect');

var _lodash = require('lodash.size');

var _lodash2 = _interopRequireDefault(_lodash);

var _selectPluginRoutes = require('./selectPluginRoutes');

var _selectPluginRoutes2 = _interopRequireDefault(_selectPluginRoutes);

var _LoadRoutePluginComponents = require('./LoadRoutePluginComponents');

var _LoadRoutePluginComponents2 = _interopRequireDefault(_LoadRoutePluginComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var decorateRoutes = function decorateRoutes(store) {
  return (0, _reselect.createSelector)(function (routes) {
    return routes;
  }, function (routes) {
    return (0, _reactRouter.createRoutes)(routes).map(decorateRoute(store));
  });
};

var decorateIndexRoute = function decorateIndexRoute(store) {
  var decorate = decorateRoute(store);
  return (0, _reselect.createSelector)(function (route) {
    return route;
  }, function (route) {
    if (Array.isArray(route)) {
      if (route.length > 1) throw new Error("got more than one route for an index route: " + route);
      route = route[0];
    }
    if (_react2.default.isValidElement(route)) {
      route = (0, _reactRouter.createRoutes)(_jsx(_reactRouter.Route, {}, void 0, route))[0].indexRoute;
    }
    return decorate(route);
  });
};

var decorateRoute = function decorateRoute(store) {
  return (0, _reselect.createSelector)(function (route) {
    return route;
  }, function (route) {
    function wrapGetChildRoutes(decorate, func) {
      for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        args[_key - 2] = arguments[_key];
      }

      return function (location, cb) {
        var result = func.apply(undefined, [location].concat(_toConsumableArray(args), [function (err, routes) {
          if (err) {
            cb(err);
            return;
          }
          cb(null, decorate(routes));
        }]));
        if (result) cb(null, decorate(result));
      };
    }

    function wrapGetIndexRoute(func) {
      for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      var decorate = decorateIndexRoute(store);
      return function (location, cb) {
        var result = func.apply(undefined, [location].concat(_toConsumableArray(args), [function (err, route) {
          if (err) {
            cb(err);
            return;
          }
          cb(null, decorate(route));
        }]));
        if (result) cb(null, decorate(result));
      };
    }

    if (!route) return route;

    var newProps = {};

    ////////////////////////////////////////////////////////////////////////////////
    // CHILD ROUTES
    ////////////////////////////////////////////////////////////////////////////////

    var getChildRoutes = route.getChildRoutes;
    var getChildRoutesFromStore = route.getChildRoutesFromStore;
    var getChildRoutesFromPlugin = route.getChildRoutesFromPlugin;
    var childRoutesKey = route.childRoutesKey;
    var childRoutes = route.childRoutes;


    if (getChildRoutes) {
      newProps.getChildRoutes = wrapGetChildRoutes(decorateRoutes(store), getChildRoutes);
    } else if (getChildRoutesFromStore) {
      newProps.getChildRoutes = wrapGetChildRoutes(decorateRoutes(store), getChildRoutesFromStore, store);
    } else if (getChildRoutesFromPlugin) {
      (function () {
        var decorate = decorateRoutes(store);
        var select = (0, _selectPluginRoutes2.default)(function (plugin) {
          return getChildRoutesFromPlugin(location, plugin);
        });
        newProps.getChildRoutes = function (location, cb) {
          return cb(null, decorate(select(store.getState())));
        };
      })();
    } else if (childRoutesKey) {
      (function () {
        var decorate = decorateRoutes(store);
        var select = (0, _selectPluginRoutes2.default)(childRoutesKey);
        newProps.getChildRoutes = function (location, cb) {
          return cb(null, decorate(select(store.getState())));
        };
      })();
    }
    if (childRoutes) newProps.childRoutes = decorateRoutes(store)(childRoutes);

    ////////////////////////////////////////////////////////////////////////////////
    // INDEX ROUTE
    ////////////////////////////////////////////////////////////////////////////////

    var getIndexRoute = route.getIndexRoute;
    var getIndexRouteFromStore = route.getIndexRouteFromStore;
    var getIndexRouteFromPlugin = route.getIndexRouteFromPlugin;
    var indexRouteKey = route.indexRouteKey;
    var indexRoute = route.indexRoute;


    if (getIndexRoute) {
      newProps.getIndexRoute = wrapGetIndexRoute(getIndexRoute);
    }
    if (getIndexRouteFromStore) {
      newProps.getIndexRoute = wrapGetIndexRoute(getIndexRouteFromStore, store);
    }
    if (getIndexRouteFromPlugin) {
      (function () {
        var decorate = decorateIndexRoute(store);
        var select = (0, _selectPluginRoutes2.default)(function (plugin) {
          return getIndexRouteFromPlugin(location, plugin);
        });
        newProps.getIndexRoute = function (location, cb) {
          return cb(null, decorate(select(store.getState())));
        };
      })();
    }
    if (indexRouteKey) {
      (function () {
        var decorate = decorateIndexRoute(store);
        var select = (0, _selectPluginRoutes2.default)(indexRouteKey);
        newProps.getIndexRoute = function (location, cb) {
          return cb(null, decorate(select(store.getState())));
        };
      })();
    }
    if (indexRoute) newProps.indexRoute = decorateIndexRoute(store)(indexRoute);

    ////////////////////////////////////////////////////////////////////////////////
    // COMPONENT
    ////////////////////////////////////////////////////////////////////////////////

    var getComponent = route.getComponent;
    var getComponentFromStore = route.getComponentFromStore;
    var getComponentFromPlugin = route.getComponentFromPlugin;
    var componentKey = route.componentKey;


    if (!getComponent && (getComponentFromStore || getComponentFromPlugin || componentKey)) {
      if (getComponentFromStore) {
        newProps.getComponent = function (nextState, cb) {
          return getComponentFromStore(nextState, store, cb);
        };
      } else if (getComponentFromPlugin || componentKey) {
        newProps.component = _LoadRoutePluginComponents2.default;
      }
    }

    return (0, _lodash2.default)(newProps) ? _extends({}, route, newProps) : route;
  });
};

exports.default = decorateRoutes;